import { PoolOptions } from 'mysql2';
import { QueryResult } from './models';
import { SlimNodeMySQLPool } from './SlimNodeMySQLPool';
export declare type PreparedStatementParameters = Record<string, unknown>;
export declare class SlimNodeMySQL {
    protected pool: SlimNodeMySQLPool;
    constructor(config: string | PoolOptions);
    query<TableModel>(sql: string, parameters?: PreparedStatementParameters): Promise<QueryResult<TableModel[]>>;
    getOne<TableModel>(sql: string, parameters?: PreparedStatementParameters): Promise<QueryResult<TableModel>>;
    getValue<TableModel, K extends keyof TableModel>(column: K, sql: string, parameters?: PreparedStatementParameters): Promise<TableModel[K] | null>;
    exists<TableModel>(sql: string, parameters?: PreparedStatementParameters): Promise<boolean>;
    close(): void;
}
